#include <stdio.h>

int board[3][3];
int turn;

void init()
{
int x; int y;
for(x = 0; x < 3; x++)
{
for(y = 0; y < 3; y++)
{
board[x][y] = 0;
}
}
turn = 0;
}

int good(int x, int y)
{
if(x > 2  || x < 0 || y > 2 || y < 0)
{
return 0;
}
if(board[x][y] != 0)
{
return 0;
}
return 1;
}

void doturn()
{
int move;
int x;
int y;
do
{
printf("Choose position, Player %d: ", (turn+1));
scanf("%d", &move);
x = 2-((move-1)/3);
y = (move-1)%3;
}
while(!good(x, y));
board[x][y] = turn + 1;
turn = 1 - turn;
}

char itc(int a)
{
if(a == 0)
return ' ';
if(a == 1)
return 'X';
if(a == 2)
return 'O';
return 0;
}

void printboard()
{
printf(" %c | %c | %c\n", itc(board[0][0]), itc(board[0][1]), itc(board[0][2]));
printf("------------\n");
printf(" %c | %c | %c\n", itc(board[1][0]), itc(board[1][1]), itc(board[1][2]));
printf("------------\n");
printf(" %c | %c | %c\n", itc(board[2][0]), itc(board[2][1]), itc(board[2][2]));
}

int checkwin()
{
if((board[0][0] != 0) && ((board[0][0] == board[0][1]) && (board[0][1] == board[0][2])))
return board[0][0];
if((board[1][0] != 0) && ((board[1][0] == board[1][1]) && (board[1][1] == board[1][2])))
return board[1][0];
if((board[2][0] != 0) && ((board[2][0] == board[2][1]) && (board[2][1] == board[2][2])))
return board[2][0];

if((board[0][0] != 0) && ((board[0][0] == board[1][0]) && (board[1][0] == board[2][0])))
return board[0][0];
if((board[0][1] != 0) && ((board[0][1] == board[1][1]) && (board[1][1] == board[2][1])))
return board[0][1];
if((board[0][2] != 0) && ((board[0][2] == board[1][2]) && (board[1][2] == board[2][2])))
return board[0][2];

if((board[0][0] != 0) && ((board[0][0] == board[1][1]) && (board[1][1] == board[2][2])))
return board[0][0];
if((board[2][0] != 0) && ((board[2][0] == board[1][1]) && (board[1][1] == board[0][2])))
return board[2][0];

int x;
int y;
int toret = 3;
for(x = 0; x < 3; x++)
{
for(y = 0; y < 3; y++)
{
if(board[x][y] == 0)
{
toret = 0;
}
}
}
return toret;
}

int main()
{
init();
printboard();
while(checkwin() == 0)
{
doturn();
printboard();
}
if(checkwin() >= 1 && checkwin() <= 2)
{
printf("\n-------------------------------------");
printf("\nPlayer %d wins!", checkwin());
printf("\n-------------------------------------\n");
}
if(checkwin() == 3)
{
printf("\n-------------------------------------");
printf("\nThe game is a tie!");
printf("\n-------------------------------------\n");
}
return 0;
}
